//****************************************************************************
//
// Program Name: EasyButton
// Created By: Dan Kozub
// Last Modified: September 1st,  2000
//
// Copyright (c) 2000-2001 by Dan Kozub
//
// Distribution: Free for commercial and individual use (GNU GPL)
// 
// ****************************************************************************

//******************************************************************************
// EasyButton.java: Applet
//
//******************************************************************************
import java.applet.*;
import java.awt.*;
import java.net.*;
import java.awt.image.*;


public class EasyButton_v2_5 extends Applet implements Runnable
{
    Thread   thread = null;
    final   int NSTATES = 2;
    final   int NIMAGES = NSTATES*4;

     String[] Text=new String[NSTATES];

     int[]      TextX       =   new int[NSTATES];
     int[]      TextY       =   new int[NSTATES];
     int[]      ImageX      =   new int[NIMAGES];
     int[]      ImageY      =   new int[NIMAGES];
     Font[]     TextFont    =   new Font[NSTATES];
     int[][]    TextColor   =   null;
     Color[]    ShadowColor =   new Color[NSTATES];
     int[]      ShadowSize  =   new int[NSTATES];
     int[]      Outline     =   new int[NSTATES];
     Image      BackgroundImage = null; 
     Image[]    hImage      =   new Image[NIMAGES];
     int[]      BGColor;
     AudioClip[] Clip       =   new AudioClip[NSTATES];

     boolean NeedRedraw     =   true;
     String[] Align         =   new String[NSTATES];
     String  Status;

     final int EffectsNumber = 10;
     Image[]         EffectImage=new Image[EffectsNumber];
    
    //max number of animated colors you can use as params to effects
    final int EffectAnimColorsNumber = 4;
    int[][]         EffectAnimColors = new int[EffectsNumber*EffectAnimColorsNumber][];
    
    //Applet by default is updated every 50 ms, ie 20 times per second
     int     UpdateTime=50;
    //if there is no animated color we can save a lot of processor time
     boolean AnimatedColorsExist    =   false;

    
     Graphics    offGraphics; // offscrean graphics
     Image       offImage;
     Dimension   offDimension;
    
     boolean displayRollover = false;
    
    //time to wake up the next time - is used for animated colors and effects
     long    NextWakeUp = 0;
    
    //Various vars for UserFont feature
         byte[]  UserFontData = null;
         Image   UserFontImage = null;
         int     UserFontImageWidth = 0;
         int     UserFontImageHeight = 0;
         int     UserFontHeight = 0;
         int     UserFontRealHeight = 0;
         int     UserFontOffsetY = 0;
         int     UserFontOffsetX = 0;
         int     UserFontDensity = 0;
         int[]   UserFontOffsets = null;
    
    //Some params to coordinate group of applets on the same page
    static  Applet  ActiveApplet[] = new Applet[10];
    // special key to update applet when neighbour applet changes
    static  int     UpdateKey[] = new int[10];
            int     LocalUpdateKey=0;

    URL hrefURL = null;         // The default URL location
    String hrefTarget = null;   // The default target frame

            
    // group number - should be unique for one page     
     int     AppletGroup = 0;
    
    
    //===========================================================
    //                  CORE   FUNCTIONS
    //===========================================================
    
    //("============init===============")
    public void init()
    {
    try{
        String href = getParameter("HREF");
        if (href != null)
        if (!href.equals("")){
                try {
                    hrefURL = new URL(getDocumentBase(), href);
                }catch (Exception e){}
        }
        }catch (Exception e) {}

        hrefTarget = getStrParam("TARGET",0,"_self");
        UpdateTime = getIntParam("UpdateTime",0,UpdateTime);
        Status = getParameter("Status"); 
        String TextStyle="";
        int text_size = 12;
        TextColor = new int[NSTATES][];
        //trying to read params for each state
        for(int p=0;p<NSTATES;p++){
            String param_name = "Text";
            if (p>0) param_name+= (p+1);
            Text[p]     = getStrParam(param_name,0, p>0 ? Text[p-1] : ""); 
            Align[p]    = getStrParam(param_name,1, p>0 ? Align[p-1] : "left"); 
            TextX[p]    = getIntParam(param_name,2, p>0 ? TextX[p-1] : -1);
            TextY[p]    = getIntParam(param_name,3, p>0 ? TextY[p-1] : -1);;

            // Creating main font 
            int style = Font.PLAIN;
            String font_name =  getStrParam(param_name,4,"Arial"); 
                text_size   =   getIntParam(param_name,5,text_size);
                TextStyle   =   getStrParam(param_name,6,TextStyle);
            if (TextStyle.indexOf("bold")!=-1)      style |= Font.BOLD;
            if (TextStyle.indexOf("italic")!=-1)    style |= Font.ITALIC;
            TextFont[p]     =   new Font(font_name,style,text_size);

            TextColor[p]    =   PrepareAnimColorParam(param_name,7,Color.black,p>0 ? TextColor[p-1] : null);
            ShadowColor[p]  =   GetColorParam       (param_name,8,p>0 ? ShadowColor[p-1] :Color.gray,false);
            ShadowSize[p]   =   getIntParam         (param_name,9,p>0 ? ShadowSize[p-1]: 1);
            Outline[p]      =   getIntParam         (param_name,10,p>0 ? Outline[p-1] : 0);;
        }

        //images
        for(int i=0;i<NIMAGES;i++){
            ImageX[i]   =   getIntParam("Image"+Integer.toString(i+1),1,ImageX[0]);
            ImageY[i]   =   getIntParam("Image"+Integer.toString(i+1),2,ImageY[0]);}


    
        BGColor =   PrepareAnimColorParam("Background",1,Color.gray,null);

        try{
            Clip[0] = getAudioClip(getDocumentBase(),getParameter("Sound"));
            Clip[1] = getAudioClip(getDocumentBase(),getParameter("Sound2"));
        } catch(Exception e){   };
    
         AppletGroup = getIntParam("Group",0,9);
         //checking if we have to draw this applet in the active state (for tab effect)
         if (getStrParam("Group",1,"passive").equals("active"))
             ActiveApplet[AppletGroup]=this;
    }

    


    //("============paint   ===================")
    public void paint(Graphics g)
    {
        update(g);
    }

    //("============update  ===================")
    public void update(Graphics g) {
        AnimatedColorsExist = false;
        Dimension d = getSize();;
        if (UserFontData==null) LoadUserFont();

        NeedRedraw = false;
            
        // create the offscreen graphics context,
        // if no good one exists.
        if ( offGraphics == null ) {
                offDimension    =   d;
                offImage        =   createImage(d.width, d.height);
                offGraphics     =   offImage.getGraphics();
        }
        
        //background    
        try {
            if (BGColor!=null)  offGraphics.setColor(GetAnimColor(BGColor));
                offGraphics.fillRect(0,0,d.width, d.height);
                if (IsLoaded(BackgroundImage)){
                    int bgwidth = BackgroundImage.getWidth(this);
                    int npaint = (d.width+1)/bgwidth+1;
                    for(int bg=0;bg<npaint;bg++)
                        offGraphics.drawImage(BackgroundImage, bgwidth*bg, 0, this);}
            } catch (Exception e){};
        int i=0;
        if (displayRollover) i=1;
        //i=1 -> rollover
        //i=0 -> normal
        //draw effects
        DrawEffects(i);

        // draw images
        for(int im=i;im<NIMAGES;im+=NSTATES){
            try {
                if (CheckState("Image"+(im+1),3))
                    if (IsLoaded(hImage[im])){
                        offGraphics.drawImage(hImage[im], ImageX[im],ImageY[im], this);
                    }
                }catch(Exception e){};

            }
        
        // pring string
        offGraphics.setFont(TextFont[i]);
        offGraphics.setColor(ShadowColor[i]);
        int x=TextX[i];
        int y=TextY[i];
        int width = StringLength(Text[i]);
        if (y==-1){ y=(d.height+offGraphics.getFontMetrics().getMaxAscent())/2-2;}
        if (Align[i].equalsIgnoreCase("left")){
            if (x==-1){ x=(d.width-width)/2;}}
        else{
            if (x==-1) x=0; 
            x = (d.width-x)-width;
        }
        // user font
        if (UserFontData!=null){     
                    PrintString(i,x,y);        
        }else{
        // system font
            offGraphics.drawString(Text[i],x,y);
            // outline
            if (Outline[i]>0){
                for(int xe=0;xe<=Outline[i];xe++){
                for(int ye=0;ye<=Outline[i];ye++){
                    offGraphics.drawString(Text[i],x+xe,y+ye);
                    offGraphics.drawString(Text[i],x-xe,y-ye);
                    offGraphics.drawString(Text[i],x-xe,y+ye);
                    offGraphics.drawString(Text[i],x+xe,y-ye);}}
            }

        Color color=GetAnimColor(TextColor[i]);
        offGraphics.setColor(color);
        offGraphics.drawString(Text[i],x-ShadowSize[i],y-ShadowSize[i]);
        }           
    // draw offscreen image
    g.drawImage(offImage, 0, 0, this);
    return;}



    //("============start===================")
    public void start()
    {
        if (thread == null){    
            thread = new Thread(this);
            thread.start();}
    }

    //("============stop()===================")
    public void stop(){
        if (thread != null){
            thread.stop();
            thread = null;}
    offGraphics = null;
    offImage = null;
    }

    //("============ModifyPath===================")
    String ModifyPath(String local){
    return local;}

    //("============run===================")
    public void run()
    {
        for(int im=0;im<NIMAGES;im++){
            hImage[im]=null;}
            
            Thread.currentThread().setPriority(Thread.MIN_PRIORITY);
            repaint();
        String image_name="";
        for(int im=0;im<NIMAGES;im++){
            image_name=getStrParam("Image"+Integer.toString(im+1),0,null);
            hImage[im] = LoadImage(image_name);
        }
        BackgroundImage = LoadImage(getStrParam("Background",0,null));
        UserFontImage = LoadImage(getStrParam("UserFont",0,null));
            
        if (UserFontData==null) LoadUserFont();

        repaint();
        if (UpdateTime==0) return;

        while(true){
        if (shouldUpdate()) repaint();
        if (AnimatedColorsExist){
            long to_sleep = UpdateTime;
            if (NextWakeUp!=1000000000000L){ 
                to_sleep = NextWakeUp-System.currentTimeMillis();
                if (to_sleep < UpdateTime) to_sleep=UpdateTime; }
            NextWakeUp = 1000000000000L;
                try{
                    Thread.currentThread().sleep(to_sleep);}
                catch (Exception e){return;}
                repaint();
        }else{
            try{
                    Thread.currentThread().sleep(UpdateTime);}
                catch (Exception e){return;}
        }
        }
    
    }

    
    //("============handleEvent===================")
    public boolean handleEvent(Event evt)
    {
        switch (evt.id) {

            case Event.MOUSE_DOWN:
                repaint();
                return true;
            case Event.MOUSE_UP:
                ActiveApplet[AppletGroup] = this;
                UpdateKey[AppletGroup]++;
                if (Clip[1]!=null) Clip[1].play();
                if (hrefURL != null && ((evt.modifiers & Event.SHIFT_MASK) == 0))
                {
                    getAppletContext().showDocument(hrefURL, hrefTarget);
                }
                return true;
            case Event.MOUSE_ENTER:
                    if (Status!=null) showStatus(Status);   
                    else showStatus(hrefURL+"");
                    displayRollover = true;
                    repaint();
                    if (Clip[0]!=null) Clip[0].play();
                    return true;
            case Event.MOUSE_EXIT:
                    displayRollover = false;
                    repaint();
                    return true;
            case Event.LOAD_FILE:
                    repaint();
                    return true;
            default:
                return super.handleEvent(evt);
        }
    }


    //===========================================================
    //                  EFFECTS   FUNCTIONS
    //===========================================================

    //("============DrawEffects===================")
    public void DrawEffects(int rollover){
    for(int effect_i=rollover;  effect_i<EffectsNumber ; effect_i+=2){
        String param = "Effect"+Integer.toString(effect_i+1);
        String effect_name = getStrParam(param,0,"none");
        if (effect_name.equalsIgnoreCase("fillrect"))   DrawEffect_FillRect     (effect_i,param,0);
        if (effect_name.equalsIgnoreCase("fillround"))  DrawEffect_FillRound    (effect_i,param);
        if (effect_name.equalsIgnoreCase("fill3drect")) DrawEffect_Fill3DRect   (effect_i, param);
        if (effect_name.equalsIgnoreCase("draw3drect")) DrawEffect_Draw3DRect   (effect_i, param,false,0);
        if (effect_name.equalsIgnoreCase("filloval"))   DrawEffect_FillOval     (effect_i, param);
        if (effect_name.equalsIgnoreCase("Gradient"))   DrawEffect_Gradient     (effect_i, param);
        if (effect_name.equalsIgnoreCase("light"))      DrawEffect_Light        (effect_i, param,true);
        if (effect_name.equalsIgnoreCase("lightline"))  DrawEffect_Light        (effect_i, param,false);
        if (effect_name.equalsIgnoreCase("rect"))       DrawEffect_Rect         (effect_i, param,false);
        if (effect_name.equalsIgnoreCase("underline"))  DrawEffect_Rect         (effect_i, param,true);
        if (effect_name.equalsIgnoreCase("drawoval"))   DrawEffect_DrawOval     (effect_i, param);
        if (effect_name.equalsIgnoreCase("sphere"))     DrawEffect_Sphere       (effect_i, param);
        if (effect_name.equalsIgnoreCase("Tab"))        DrawEffect_Tab          (effect_i, param);
    
    }
    };

    //--------------------------------------------------------------------------
    public void DrawEffect_FillRect(int effect_i, String param,int shift_y){
    Color fill_color = GetColorParam(param,4,null,false);
    if (fill_color==null) fill_color = GetColorParam(param,1,Color.black,false);
    Dimension d = getSize();
        offGraphics.setColor(fill_color);
        offGraphics.fillRect(0,shift_y,d.width, d.height);
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_Rect(int effect_i, String param, boolean underline_only){
    int width = getIntParam( param,1,1);
    Dimension d = getSize();
    Color fill_color = Color.gray;
    int[] last_anim_color = null;
    for(int i=0; i< width; i++){
        if (i<3){
            int anim_color_i =effect_i+EffectsNumber*i;         
            if (EffectAnimColors[anim_color_i]==null)
                    EffectAnimColors[anim_color_i]=PrepareAnimColorParam(param,2+i,fill_color,last_anim_color);
            fill_color = GetAnimColor(EffectAnimColors[anim_color_i]);
            last_anim_color = EffectAnimColors[anim_color_i];
        }else {
            fill_color = GetColorParam(param,2+i,fill_color,false);}
        DrawEffect_Rect(i,d,fill_color,underline_only);
    }
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_Rect(int i,Dimension d, Color fill_color, boolean underline_only){
        offGraphics.setColor(fill_color);
        if (underline_only)
            offGraphics.drawLine(0,d.height-i-1,d.width, d.height-i-1);
        else
            offGraphics.drawRect(0+i,0+i,d.width-i*2-1, d.height-i*2-1);
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_FillRound(int effect_i, String param){
    Color fill_color = GetColorParam(param,1,Color.black,false);
    int radius = getIntParam(param,3,5);
    Dimension d = getSize();
        offGraphics.setColor(fill_color);
        offGraphics.fillRoundRect(0,0,d.width-1, d.height-1,radius,radius);
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_Fill3DRect(int effect_i, String param){
    DrawEffect_FillRect(effect_i,param,0);
    DrawEffect_Draw3DRect(effect_i,param,false,0);
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_Tab(int effect_i, String param){
    int width = getIntParam(param,1,1);
    Color light_color   = GetColorParam(param,2,Color.gray,false);
    Color fill_color    = GetColorParam(param,4,Color.black,false);
    Color p_light_color = GetColorParam(param,5,Color.gray,false);
    Color p_dark_color  = GetColorParam(param,6,Color.black,false);
    Color p_fill_color  = GetColorParam(param,7,Color.black,false);
    Dimension d = getSize();;
    
    int shift_y = width;
    if (isActiveApplet())   shift_y=0;
    
    if (isActiveApplet()){
        DrawEffect_FillRect(effect_i,param,shift_y);
        DrawEffect_Draw3DRect(effect_i,param,true,shift_y);}
    else{
        offGraphics.setColor(p_fill_color);
        offGraphics.fillRect(0,shift_y,d.width,d.height);
        for(int i=0; i< width; i++){
            DrawTopLine(p_light_color,d,0,i+shift_y,0);
            DrawBottomLine(light_color,d,0,i+width,0);}
        DrawRightLine(p_dark_color,d,0,shift_y,width*2);
    }   
    for(int i=0; i< width; i++)
            DrawBottomLine(fill_color,d,0,i,0);
    }
    //--------------------------------------------------------------------------
    public boolean CheckState(String param, int param_n){
        String state = getStrParam(param,param_n,"");
        if (state.equals("passive") && isActiveApplet()) return false;
        if (state.equals("active") && !isActiveApplet()) return false;
        return true;
    }
    //--------------------------------------------------------------------------
    public void DrawLine(Color color,int x,int y,int x2,int y2){
        offGraphics.setColor(color);
        offGraphics.drawLine(x,y,x2,y2);
    }
    //--------------------------------------------------------------------------
    public void DrawTopLine(Color color,Dimension d, int dx,int dy,int dx2){
        offGraphics.setColor(color);
        offGraphics.drawLine(dx,dy,d.width-1-dx2,dy);   }
    //--------------------------------------------------------------------------
    public void DrawBottomLine(Color color,Dimension d, int dx,int dy,int dx2){
        offGraphics.setColor(color);
        offGraphics.drawLine(dx,d.height-1-dy,d.width-dx2,d.height-1-dy);   }
    //--------------------------------------------------------------------------
    public void DrawLeftLine(Color color,Dimension d, int dx,int dy,int dy2){
        offGraphics.setColor(color);
        offGraphics.drawLine(dx,dy,dx,d.height-1-dy2);  }
    //--------------------------------------------------------------------------
    public void DrawRightLine(Color color,Dimension d, int dx,int dy,int dy2){
        offGraphics.setColor(color);
        offGraphics.drawLine(d.width-1-dx,dy,d.width-1-dx,d.height-1-dy2);  }
    //--------------------------------------------------------------------------
    public void DrawEffect_Draw3DRect(int effect_i, String param,boolean no_bottom,int shift_y){
    int width = getIntParam(param,1,1);
    Color light_color = GetColorParam(param,2,Color.gray,false);
    Color dark_color = GetColorParam(param,3,Color.black,false);
    Dimension d = getSize();;
    if (no_bottom) d.height+=width;
    for(int i=0; i< width; i++){
        DrawTopLine(light_color,d,i,shift_y+i,i);
        DrawLeftLine(light_color,d,i,shift_y+i,i);
        DrawBottomLine(dark_color,d,i,i,i);
        DrawRightLine(dark_color,d,i,shift_y+i,i);
    }
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_FillOval(int effect_i, String param){
    Color fill_color = GetColorParam(param,1,Color.black,false);
    Dimension d = getSize();
        offGraphics.setColor(fill_color);
        offGraphics.fillOval(0,0,d.width, d.height);
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_DrawOval(int effect_i, String param){
    int width = getIntParam(param,1,1);
    Color fill_color = GetColorParam(param,2,Color.black,false);
    Dimension d = getSize();
    for(int i=0; i< width; i++){
        fill_color = GetColorParam(param,2+i,fill_color,false);
        offGraphics.setColor(fill_color);
        offGraphics.drawOval(0+i,0+i,d.width-i*2-1, d.height-i*2-1);
    }
    }
    //--------------------------------------------------------------------------
    public void DrawEffect_Sphere(int effect_i, String param){
    Dimension d = getSize();
    int p=1;
    Color color1 = GetColorParam(param,p++,Color.black,false);
    Color color2 = GetColorParam(param,p++,Color.white,false);
    Color color3 = GetColorParam(param,p++,Color.white,false);
    Color background = GetColorParam(param,p++,Color.white,false);
    int x = getIntParam(param,p++,1);
    int y = getIntParam(param,p++,d.height/2);
    int size = getIntParam(param,p++,1);
    double std_len = (size/2)*Math.sqrt(1.0+1+3*3);
    for(int j=y-size/2; j< y+size/2; j++){
    for(int i=x-size/2; i< x+size/2; i++){
        double dx=i-x; double dy=j-y; 
        double r2 = size*size/4.0-dx*dx-dy*dy;
        if (r2<0) continue;
        double dz=Math.sqrt(r2);
        double cos = (-1*dx-1*dy*1+3*dz)/std_len;
        double k1= (cos+1)/2; 
        k1 =k1*k1*k1*k1; 
        Color color = Blend3Colors(color1,color2,color3,(float)k1);
        double to_edge = size/2-Math.sqrt(dx*dx+dy*dy);
        if (to_edge<=1) color = BlendColors(color,background,(float)to_edge);
        offGraphics.setColor(color);
        offGraphics.drawLine(i,j,i,j);

    }
    }
    return;}
    //--------------------------------------------------------------------------
    public void DrawEffect_Light(int effect_i, String param,boolean one_light){
    if (EffectImage[effect_i] != null){
        offGraphics.drawImage(EffectImage[effect_i],0,0,this);
        return;}
    Dimension d = getSize();
    EffectImage[effect_i] = createImage(d.width, d.height);
    Graphics effect_graphics = EffectImage[effect_i].getGraphics();
    int y=d.height/2; 
    int x=d.width/2;
    int x1 = x; int x2=x;
    if (!one_light) { x1=y; x2=d.width-y;}
    Color color1 = GetColorParam(param,1,Color.black,false);
    Color color2 = GetColorParam(param,2,Color.white,false);
    float k_y=(float)x1/y;
    double max_len = x1;
    for(int j=0; j< d.height; j++){
    for(int i=0; i< d.width; i++){
        x=i;
        if (i<x1) x=x1;
        if (i>x2) x=x2;
        double len = Math.sqrt(Math.pow(x-i,2)+Math.pow((y-j)*k_y,2));      
        float k1 = (float)((max_len-len)/max_len);
        if (k1<0) k1=0;
        effect_graphics.setColor(BlendColors(color1,color2,k1));
        effect_graphics.drawLine(i,j,i,j);
    }
    }
    offGraphics.drawImage(EffectImage[effect_i],0,0,this);
    return;}
    //--------------------------------------------------------------------------
    public void DrawEffect_Gradient(int effect_i, String param){
    if (EffectAnimColors[effect_i]==null)
                    EffectAnimColors[effect_i]=PrepareAnimColorParam(param,1,Color.black,null);
    Color color1 = GetAnimColor(EffectAnimColors[effect_i]);
    if (EffectAnimColors[effect_i+EffectsNumber]==null)
                    EffectAnimColors[effect_i+EffectsNumber]=PrepareAnimColorParam(param,2,Color.black,null);
    Color color2 = GetAnimColor(EffectAnimColors[effect_i+EffectsNumber]);
        
    Dimension d = getSize();;
    boolean vertical  = false;  if (getStrParam(param,3,"horizontal").equalsIgnoreCase("vertical")) vertical  = true;
    boolean centered  = false;  if (getStrParam(param,4,"").equalsIgnoreCase("centered")) centered  = true;
    int len =vertical ? d.height : d.width;
    int x=0; int y=0;
    if (centered) { len = len/2+1; 
        if (vertical)  y=d.height/2; else x=d.width/2;}
    for(int i=0; i< len; i++){
        float k1 = (float)(len-i)/len;
        offGraphics.setColor(BlendColors(color1,color2,k1));
        if (!vertical) offGraphics.drawLine(x+i,0,x+i,d.height);
            else  offGraphics.drawLine(0,y+i,d.width,y+i);
        if (centered){
        if (!vertical) offGraphics.drawLine(x-i,0,x-i,d.height);
            else  offGraphics.drawLine(0,y-i,d.width,y-i);
        }
    }
    }

    //===========================================================
    //                  COLOR   FUNCTIONS
    //===========================================================
    
    
    //("============BlendColors===================")
    Color BlendColors(Color color1, Color color2, float proportion){
        float R1=color1.getRed(); float G1=color1.getGreen(); float B1=color1.getBlue();
        float R2=color2.getRed(); float G2=color2.getGreen(); float B2=color2.getBlue();
        float k1 = proportion/255;
        float k2= (1-proportion)/255;
    return new Color(k1*R1+k2*R2,k1*G1+k2*G2,k1*B1+k2*B2);}

    //("============Blend3Colors===================")
    Color Blend3Colors(Color color1, Color color2, Color color3, float proportion){
    if (proportion>0.5) return BlendColors(color1,color2,(float)(proportion-0.5)*2);
    return BlendColors(color2,color3,proportion*2);}

    
    //===========================================================
    //                  USERFONT   FUNCTIONS
    //===========================================================

    //("============LoadUserFont===================")
     boolean LoadUserFont(){
     if (UserFontImageWidth!=0) return false;
     if (!IsLoaded(UserFontImage))return false;
     UserFontImageWidth = UserFontImage.getWidth(this);
     UserFontImageHeight = UserFontImage.getHeight(this);
     UserFontHeight =  (UserFontImageHeight+7)/14; //getIntParam("UserFont",2,20);
     UserFontDensity =  getIntParam("UserFont",1,100);
     UserFontRealHeight =   getIntParam("UserFont",2,UserFontHeight*7/10);
     UserFontOffsetY =   getIntParam("UserFont",3,0);
     UserFontOffsetX =   getIntParam("UserFont",4,0);
     int[] TempData= new int [UserFontImageWidth*UserFontImageHeight];
     PixelGrabber  pg  =  new  PixelGrabber(UserFontImage,  0,  0,  UserFontImageWidth,  UserFontImageHeight, TempData,  0,  UserFontImageWidth);
     try  { pg.grabPixels();}  
     catch  (InterruptedException  e)  {
                 UserFontData = null;
                 return false;}
     if  ((pg.status()  &  ImageObserver.ABORT)  !=  0){
                 UserFontData = null;
                 return false;}
     UserFontOffsets = new int[17*14];// 14 lines of letter and 17 dividers in each line
     int limit_i = 0;
     for(int j = 0; j<UserFontImageWidth*UserFontImageHeight;j++){
        if (IsBlue(TempData[j])){// blue point found
             UserFontOffsets[limit_i]=j; // remember offset
             limit_i++;
             if (limit_i >= 14*17) break; 
             if (limit_i%17==0){ // reache the end of line and jump to the next
                 j+= UserFontImageWidth*(UserFontHeight-3)-2; //jump to next line of letters
              }
             else j+=3; // advancing a little bit
         }
     }
      if (limit_i != 14*17){
             System.out.println("Error when trying to load user font ");
             return false; }
     UserFontData  = new byte [UserFontImageWidth*UserFontImageHeight];
         for(int i = 0; i<UserFontImageWidth*UserFontImageHeight;i++){
            UserFontData[i] = (byte)((TempData[i]&0xFF0000)>>16);
     }
     TempData = null;
     UserFontImage = null;
     return true;}   

     //("============IsBlue===================")
     boolean IsBlue(int value){
         int blue = value&0xFF;
         int red = (value&0xFF0000)>>16;
         return (blue-red>100);
     }   

    //("============PrintString===================")
     boolean PrintString(int rollover,int x, int y){
     if (UserFontData==null) return false;
     String string = Text[rollover];
     Color color1 = GetAnimColor(TextColor[rollover]);
     Color color2 = ShadowColor[rollover];
     for(int i=0;i<string.length();i++){
         char chr = string.charAt(i);
         x+=PrintChar(chr,x,y,color1,color2)*UserFontDensity/100;;
     }
     return false;}  

    //("============PrintChar===================")
     int PrintChar(char Char,int x, int y,Color color1,Color color2){
     int offset = GetCharOffset(Char);
     int width = GetCharWidth(Char);
     offset+=div_width/6;
     Color color=Color.black;
     int prev_R = -1;
     y = y-UserFontRealHeight; x = x+1;
     try{
     for(int i = 0; i<width;i++){
     for(int j = 0; j<UserFontHeight-2;j++){
        int R=UserFontData[offset+i+(j-1+UserFontOffsetY)*UserFontImageWidth+UserFontOffsetX];
             if (R<0) R=256+R;
             if (R>245) continue;
             if (prev_R!=R)color= BlendColors(color2,color1,(float)R/255);
             prev_R =R;
             offGraphics.setColor(color);
             offGraphics.drawLine(x+i,y+j,x+i,y+j);
         
     }
     }
     }catch(Exception e){}
     return width;}

   

    //("============GetCharOffset===================")
     int GetCharOffset(int chr){
         chr-=32;
         return UserFontOffsets[(chr/16)*17+(chr%16)];
     }

    //---------------------------------
     int div_width = 0;
     int GetCharWidth(int chr){
     if (div_width==0 && chr!='|') div_width = GetCharWidth('|');
     return UserFontOffsets[((chr-32)/16)*17+((chr-32)%16)+1]-GetCharOffset(chr)-div_width/3;
     }
    


    //("============StringLength===================")
     int StringLength(String string){
     if (UserFontData==null)     
              return offGraphics.getFontMetrics().stringWidth(string);
     int width=0;
          for(int i=0;i<string.length();i++){
             char chr = string.charAt(i);
             width+=GetCharWidth(chr)*UserFontDensity/100;;
         }
    return width;}

    //===========================================================
    //                  TABEFFECT   FUNCTIONS
    //===========================================================

    //("============isActiveApplet===============")
    // returns true if this applet was pressed the last
    boolean isActiveApplet(){ 
                return this == ActiveApplet[AppletGroup];}
    //("============shouldUpdate===============")
    // returns true if another applet was pressed and this applet needs updating.
    boolean shouldUpdate(){
                if (LocalUpdateKey==UpdateKey[AppletGroup]) return false;
                    LocalUpdateKey=UpdateKey[AppletGroup];
                    return true;}           



    //===========================================================
    //                  UTILITY   FUNCTIONS
    //===========================================================

    //("============GetFieldsNumber===============")
     int GetFieldsNumber(String param, String div){
        if (param == null) return 0;
        int inx = 0; int nfields = 0;
        while(inx != -1){
            inx = param.indexOf(div,inx+1);
            nfields++;}
    return nfields;};

    //("============GetField======================")
     String GetField(String param, String div, int field){
        if (param==null) return null;
        int inx = -1; int nfields = 0;
        int old_inx = 0;
        while(true){
            old_inx = inx+1;
            inx = param.indexOf(div,old_inx);
            if (nfields == field){
                if (inx == -1) inx = param.length();
                String substr = param.substring(old_inx,inx)+"";
                return substr;}
            if (inx == -1) break; 
            nfields++;}
    return null;};
    
    //("============getIntParam===================")
    int getIntParam(String param,int field,int def_val){
        String str = getStrParam(param,field,null);
        if (str==null) return def_val;
    return Integer.parseInt(str);}
    
    //("============getIntParam===================")
    double GetDblParam(String param,int field,double def_val){
        String str = getStrParam(param,field,null);
        if (str==null) return def_val;
    return Double.valueOf(str).doubleValue();}
    
    //("============getStrParam===================")
    String getStrParam(String param,int field,String def_val){
    try{
        String param_val=getParameter(param);
        String str = GetField(param_val,"|",field);
        if (str==null || str.equalsIgnoreCase("")) return def_val;
        return str;}
    catch(Exception e){
    };
    return def_val;}

    //("============GetColorParam===================")
    Color   GetColorParam(String param,int field, Color def_color, boolean use_param_as_source){
    String string;      
    if (use_param_as_source) string = param;
    else string = GetField(getParameter(param),"|",field);
    if (string==null || string.equalsIgnoreCase("")) return def_color;
    if (string.charAt(0)=='#')
        return new Color(Integer.parseInt(string.substring(1), 16));
    int plus = string.indexOf("+");     
    int minus = string.indexOf("-");    
    int sign = plus+minus;
    int color_shift = 0;
        if (sign>0) {  
            try{
                color_shift = Integer.parseInt(string.substring(sign+2));
            } catch (Exception e){
                color_shift=50;}
            string = string.substring(0,sign);}
    String stdcolors = "red     green   blue    pink    orange  magenta cyan    white   yellow  gray    grey    black   darkGraylightGray";
    Color color =  def_color;
    try{
    int std = stdcolors.indexOf(string);
        switch (std){
        case -1: break;
        case 0*8: color = Color.red; break; 
        case 1*8: color = Color.green; break; 
        case 2*8: color = Color.blue; break;    
        case 3*8: color = Color.pink; break; 
        case 4*8: color = Color.orange; break;  
        case 5*8: color = Color.magenta; break; 
        case 6*8: color = Color.cyan; break;    
        case 7*8: color = Color.white; break; 
        case 8*8: color = Color.yellow; break;  
        case 9*8: color = Color.gray; break; 
        case 10*8: color = Color.gray; break;   
        case 11*8: color = Color.black; break; 
        case 12*8: color = Color.darkGray; break;  
        case 13*8: color = Color.lightGray; break; };}
    catch(Exception e){
    };
    if (plus>0) color = BlendColors(Color.white,color,(float)(color_shift/100.0));
    if (minus>0) color = BlendColors(Color.black,color,(float)(color_shift/100.0));
    return color;}
    
    
    //("============GetAnimColor===================")
    Color GetAnimColor(int anim_color[]){
        int ncolors = anim_color[0];
        if (ncolors==1) return new Color(anim_color[3]);
        AnimatedColorsExist = true;
        int total_time = anim_color[1];
        int time_in_cycle =  (int)((System.currentTimeMillis()-anim_color[(ncolors+1)*2])%total_time); 
        total_time = 0;
        for(int i=0; i< ncolors; i++){
            int duration = anim_color[(i+1)*2];
            if (time_in_cycle>=total_time && time_in_cycle < total_time+Math.abs(duration)){
                Color first_color = new Color(anim_color[(i+1)*2+1]);
                Color second_color = new Color(anim_color[(   ((i+1)%ncolors)  +1)*2+1]);
                if (first_color.getRGB() == second_color.getRGB() || duration<0){
                    long now = System.currentTimeMillis();
                    long pause = total_time+Math.abs(duration)-time_in_cycle;
                    long next_wakeup = now+pause;
                    if (NextWakeUp>next_wakeup)
                                    NextWakeUp=next_wakeup;
                }else{
                NextWakeUp = 0;
                }
                if (duration<0) return first_color;
                float propotion = (float)(time_in_cycle-total_time)/duration;
                return BlendColors(first_color,second_color,1-propotion);                            
            } 
        total_time+=Math.abs(duration);}
    return Color.black;}
    //--------------------------------------------------------------------------
    // animated color - data format:
    // int number  | value
    // 0            number of colors in set
    // 1            total time of the cycle
    // 2            time for the color1
    // 3            color1 - RGB value
    // 4            time2
    // 5            color2
    // 6            cycle shift
    
    //("============PrepareAnimColorParam===================")
    int[]   PrepareAnimColorParam(String param,int field, Color def_color, int [] def_anim_color){
    String string = GetField(getParameter(param),"|",field);
    if (string==null || string.equalsIgnoreCase("")){
            if (def_anim_color!=null) return def_anim_color;
            int[] anim_color=new int[4];
            anim_color[0]=1;
            anim_color[3]=def_color.getRGB();
            return anim_color;}         
    int ncol = GetFieldsNumber(string,">");
    int[] anim_color = new int[(ncol+2)*2];
    anim_color[0]=ncol;
    if (ncol==1){
            anim_color[3]=GetColorParam(param,field,def_color,false).getRGB();              
            return anim_color;}
    int total_time = 0;
    // cycle shift
    anim_color[(ncol+1)*2]= GetIntField(GetField(string,">",0),",",2,0);
    for(int color_i=0; color_i<ncol; color_i++){
        String color_str = GetField(string,">",color_i);
        if (color_str==null || color_str==null) break;
        int duration = GetIntField(color_str,",",1,100);
        Color color = GetColorParam(GetField(color_str,",",0),0,def_color,true);
        anim_color[(color_i+1)*2]=duration;
        anim_color[(color_i+1)*2+1]=color.getRGB();
        total_time+= Math.abs(duration);

    }
    anim_color[1]=total_time;
    return anim_color;};
    
    //("============GetIntField ===================")
    int GetIntField(String to_value,String divider,int field, int default_value){
        if(to_value=="" || to_value==null) return default_value;
        int value = default_value;
        try {
                value = Integer.parseInt(GetField(to_value,divider,field));}
        catch(Exception e) {};
    return value;}
    
    //("============showParseError  ===================")
    void showParseError(Exception e) {
        String errorMsg = "Parse error: "+e;
        showStatus(errorMsg);
        System.err.println(errorMsg);
        repaint();
    }

    //---------------------------------
    Image LoadImage(String image_name){
    Image result = null;
    try{
        if (image_name!=null && image_name!=""){
            result = getImage(getDocumentBase(),image_name);
            prepareImage(result,this);
            }
    }catch(Exception e){
        System.out.println("run - Exception loading image "+image_name);
    }
    return result;}

    //("============IsLoaded===================")
    boolean IsLoaded(Image image){
        if (image==null) return false;
        return (checkImage(image,this)&(ImageObserver.ALLBITS|ImageObserver.WIDTH|ImageObserver.HEIGHT))!=0; 
    };

}
